void Build_derived_type(
         float*   a_ptr, 
         float*   b_ptr,
         int*     n_ptr,
         MPI_Datatype* mesg_mpi_ptr){

/*  +----------------------------------+
 *  | Number of elements in each block |
 *  | of the new type.                 |
 *  +----------------------------------+
 */
      int block_lengths[3];

/*  +---------------------------------+
 *  | Relative location of the blocks |
 *  | from the start of the new type. |
 *  +---------------------------------+
 */
 
      MPI_Aint relloc[3];

/*  +---------------------------------+
 *  | MPI types of the elements.      |
 *  +---------------------------------+
 */
 
      MPI_Datatype typelist[3];

/*  +---------------------------------+
 *  | Variables used in calculating   |
 *  | addresses.                      |
 *  +---------------------------------+
 */

      MPI_Aint start_add;
      MPI_Aint address  ;

/*  +---------------------------------+
 *  | Set the block lengths.          |
 *  +---------------------------------+
 */

      block_lengths[0]=1;
      block_lengths[1]=1;
      block_lengths[2]=1;

/*  +---------------------------------+
 *  | Define the datatypes.           |
 *  +---------------------------------+
 */

      typelist[0]=MPI_FLOAT;
      typelist[1]=MPI_FLOAT;
      typelist[2]=MPI_INT  ;

/*  +---------------------------------+
 *  | Find out the address and the    |
 *  | calculate the relative location.|
 *  +---------------------------------+
 */

      MPI_Address(a_ptr, &start_add);
      relloc[0]=0                   ;

      MPI_Address(b_ptr, &address  );
      relloc[1]=address-start_add   ;

      MPI_Address(n_ptr, &address  );
      relloc[2]=address-start_add   ;

/*  +---------------------------------+
 *  | Build derived datatype.         |
 *  +---------------------------------+
 */

      MPI_Type_struct(3, block_lengths, relloc, 
                      typelist, mesg_mpi_ptr);

/*  +---------------------------------+
 *  | Commit the derived datatype.    |
 *  +---------------------------------+
 */

      MPI_Type_commit(mesg_mpi_ptr);

}
